/* Dottest.cc

   Dot-product test on fopCinjof.

   The program writes to standard output
   the fractional error between the two sides of the
   Dot product test.
   */

#include <Axis.h>
#include <Axislist.h>
#include <iostream.h>
#include <fopdotprod.h>

#include <farray.h>
#include <fopcinjof.h>

int main() {

/**********************************/

    // Create the filter for the operator
    floatArray hi(3,2);
    hi(0,0) = 2; hi(1,0) = -100; hi(2,0) = 1;
    hi(0,1) = 1; hi(1,1) =    2; hi(2,1) = 3;

    cout << "\n\nDot product test, simple convolutional operator \n";
    cout << hi;

	// The Axis to operate on
    Axis t(1.0,1.0,100,"t");
    Axis x(1.0,1.0,100,"x");

	// Set up the input Axislist
    Axislist inlist(2);
    inlist.list[0] = t; 
    inlist.list[1] = x;

	// Set up the output Axislist, longer by (filter length)-1
    Axislist outlist = inlist;

	// Construct the operator
    fopCinjof op(hi,"t","x",0,0);

/***********************************/

	// Call Dot-product test routine
	// and output result
    cout << "\n Answer is : " << fopdotprod(inlist,outlist,op) << "\n";

    return(0);
}
