// fopcinjof.h
#ifndef _OP_CINJOF_F_
#define _OP_CINJOF_F_

#include <fopone.h>
#include <Axislist.h>
#include <Cube/sepinput.h>

class fopCinjof : public fopone {
  public:
       // construct operator from an array; apply to axis axisname;
       // sample interval of input data must be delta;
    fopCinjof( floatArray & filt,
	     const char* axname0, const char* axname1,
	     const float  delta0, const float  delta1, 
	     const int    mylag0, const int    mylag1);
       // sample interval of input data is irrelevant;
    fopCinjof( floatArray & filt,
	     const char* axname0, const char* axname1,
	     const int    mylag0, const int    mylag1);
       // construct operator from floatspace; 
       // if usedelta==0 then the sample rate of data is irrelevant;
    fopCinjof(const floatspace & filtsp, int usedelta = 1, 
	     const int mylag0 = 0 , const int mylag1 = 0);
  private:
    void apply(floatArray &,floatArray &,int,
		const Axislist &,const Axislist &) const;
    void forwardwildtrans (Axislist &,const Axislist &) const;
    void adjointwildtrans (Axislist &,const Axislist &) const;
    int lag0;
    int lag1;
    floatArray filter;
};

#endif
