/* Conv.cc
  Conv filter=myfilter.H  adj=0 < in.H > out.H
  Convolves in.H with filter.H
  */
 
#include <iostream.h>
#include <SEPinit.h>
#include <fopconv.h>
#include <farray.h>
#include <Processnew.h>

main(int argc,char **argv) {
          // begin: Site specific code
    SepInput * sepInput = SEPinit(argc,argv,SOURCE);
    floatspace input(sepInput);
          // flags from command line
    int adj = 0;
    sepInput->Getch("adj",adj);
    int inv=0; 
    sepInput->Getch("inv",inv);
    int niter=1; 
    sepInput->Getch("niter",niter);
         // filter from seplib file
    char filname[100];
    if (!(sepInput->Getch("filter",filname)))
      seperr("filter must be specified.\n");
    SepInput * sepinfilter = new SepInput(filname);
    floatspace filtsp(sepinfilter);

         // make convolve operator 
    fopConv myconv(filtsp,0);
         // apply operator to input data
    floatspacearray output = Processnew( input, myconv, adj, inv, niter );

         // site specific output 
    SepOutput *sepout = new SepOutput( "stdout", output(0,0).sepData() );

    delete sepout;
    UnRef(sepinfilter);
    UnRef(sepInput);

    return 0;
}
