/* Dottest.cc

   Dot-product test on fopConv.

   The program writes to standard output
   the fractional error between the two sides of the
   Dot product test.
   */

#include <Axis.h>
#include <Axislist.h>
#include <iostream.h>
#include <fopdotprod.h>

#include <farray.h>
#include <fopconv.h>

int main() {

/**********************************/

    // Create the filter for the operator
    floatArray hi(3);
    hi(0) = 2; hi(1) = -1; hi(2) = -100;

    cout << "\n\nDot product test, simple convolutional operator \n";
    cout << hi;

	// Construct the operator
    fopConv op(hi,"x");

	// The Axis to operate on
    Axis in(1.0,1.0,100,"x");

	// Set up the input Axislist
    Axislist inlist = (Axislist)in;

	// Set up the output Axislist, longer by (filter length)-1
    Axis out = in;
    out.length += ::rows(hi) -1 ;
    Axislist outlist = (Axislist)out;

/***********************************/

	// Call Dot-product test routine
	// and output result
    cout << "\n Answer is : " << fopdotprod(inlist,outlist,op) << "\n";

return(0);
}
