// fopconv2.h
#ifndef _OP_CONV2_F_
#define _OP_CONV2_F_

#include <fopone.h>
#include <Axislist.h>
#include <Cube/sepinput.h>

class fopConv2 : public fopone {
  public:
       // construct operator from an array; apply to axis axisname;
       // sample interval of input data must be delta;
    fopConv2( floatArray & filt,const char* axisname, float delta );
       // sample interval of input data is irrelevant;
    fopConv2( floatArray & filt,const char* axisname );
       // construct operator from floatspace; 
       // if usedelta==0 then the sample rate of data is irrelevant;
    fopConv2(const floatspace & filtsp, int usedelta = 1);
  private:
    void apply(floatArray &,floatArray &,int,
		const Axislist &,const Axislist &) const;
    void forwardwildtrans (Axislist &,const Axislist &) const;
    void adjointwildtrans (Axislist &,const Axislist &) const;
    floatArray filter;
};

#endif
